'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @category controls
 * @component input
 * @variations collab-ui-react
 */

var InputHelper = function InputHelper(_ref) {
  var message = _ref.message,
      className = _ref.className;

  return _react2.default.createElement(
    'p',
    { className: 'cui-input__help-text ' + className },
    message
  );
};

InputHelper.defaultProps = {
  className: ''
};

InputHelper.displayName = 'InputHelper';

exports.default = InputHelper;

/**
* @name Input Helper
* @description Inputs are useful.
*
* @category controls
* @component input
* @section Input Helper
*
* @js

import {
  Checkbox,
  InputHelper
} from '@collab-ui/react';

export default function Default() {
  return (
    <div className='row'>
      <Checkbox
        value='us'
        label='us'
        htmlId='inputHelper1'
        onChange={()=>{}}
      >
        <InputHelper message={'I\'m here to help'} />
      </Checkbox>
    </div>
  );
}

**/

module.exports = exports['default'];